Apache Struts API Documentation: Class FastHashMap

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.struts.util
Class FastHashMap

    java.lang.Object
      |
      +--java.util.AbstractMap
            |
            +--java.util.HashMap
                  |
                  +--org.apache.struts.util.FastHashMap

All Implemented Interfaces:
  java.lang.Cloneable, java.util.Map, java.io.Serializable

Deprecated. At some point after Struts 1.0 final, will be replaced by an equivalent class in the Jakarta Commons Collections package.

public class FastHashMap
extends java.util.HashMap

A customized implementation of `java.util.HashMap` designed to operate in a multithreaded environment where the large majority of method calls are read-only, instead of structural changes. When operating in "fast" mode, read calls are non-synchronized and write calls perform the following steps:

- Clone the existing collection
- Perform the modification on the clone
- Replace the existing collection with the (modified) clone

When first created, objects of this class default to "slow" mode, where all accesses of any type are synchronized but no cloning takes place. This is appropriate for initially populating the collection, followed by a switch to "fast" mode (by calling `setFast(true)`) after initialization is complete.

NOTE: If you are creating and accessing a `HashMap` only within a single thread, you should use `java.util.HashMap` directly (with no synchronization), for maximum performance.

Version:
  $Revision: 1.1 $ $Date: 2001-09-17 21:13:30 +0100 (Mon, 17 Sep 2001) $
Author:
  Craig R. McClanahan
See Also:
  Serialized Form

Inner classes inherited from class java.util.Map
`java.util.Map.Entry`

Field Summary
`protected boolean` | `fast` Deprecated. Are we operating in "fast" mode?
`protected java.util.HashMap` | `map` Deprecated. The underlying map we are managing.

Fields inherited from class java.util.HashMap
`count, emptyHashIterator, ENTRIES, entrySet, KEYS, keySet, loadFactor, modCount, serialVersionUID, table, threshold, values, VALUES`

Constructor Summary
`FastHashMap()` Deprecated. Construct a an empty map.
`FastHashMap(int capacity)` Deprecated. Construct an empty map with the specified capacity.
`FastHashMap(int capacity, float factor)` Deprecated. Construct an empty map with the specified capacity and load factor.
`FastHashMap(java.util.Map map)` Deprecated. Construct a new map with the same mappings as the specified map.

Method Summary
`void` | `clear()` Deprecated. Remove all mappings from this map.
`java.lang.Object` | `clone()` Deprecated. Return a shallow copy of this `FastHashMap` instance.
`boolean` | `containsKey(java.lang.Object key)` Deprecated. Return `true` if this map contains a mapping for the specified key.
`boolean` | `containsValue(java.lang.Object value)` Deprecated. Return `true` if this map contains one or more keys mapping to the specified value.
`java.util.Set` | `entrySet()` Deprecated. Return a collection view of the mappings contained in this map.
`boolean` | `equals(java.lang.Object o)` Deprecated. Compare the specified object with this list for equality.
`java.lang.Object` | `get(java.lang.Object key)` Deprecated. Return the value to which this map maps the specified key.
`boolean` | `getFast()` Deprecated.
`int` | `hashCode()` Deprecated. Return the hash code value for this map.
`boolean` | `isEmpty()` Deprecated. Return `true` if this map contains no mappings.
`java.util.Set` | `keySet()` Deprecated. Return a set view of the keys contained in this map.
`java.lang.Object` | `put(java.lang.Object key, java.lang.Object value)` Deprecated. Associate the specified value with the specified key in this map.
`void` | `putAll(java.util.Map in)` Deprecated. Copy all of the mappings from the specified map to this one, replacing any mappings with the same keys.
`java.lang.Object` | `remove(java.lang.Object key)` Deprecated. Remove any mapping for this key, and return any previously mapped value.
`void` | `setFast(boolean fast)` Deprecated.
`int` | `size()` Deprecated. Return the number of key-value mappings in this map.
`java.util.Collection` | `values()` Deprecated. Return a collection view of the values contained in this map.

Methods inherited from class java.util.HashMap
`, capacity, getHashIterator, loadFactor, readObject, rehash, writeObject`

Methods inherited from class java.util.AbstractMap
`toString`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, registerNatives, wait, wait, wait`

Field Detail

### map

    protected java.util.HashMap map

  Deprecated.
  The underlying map we are managing.

### fast

    protected boolean fast

  Deprecated.
  Are we operating in "fast" mode?

Constructor Detail

### FastHashMap

    public FastHashMap()

  Deprecated.
  Construct a an empty map.

### FastHashMap

    public FastHashMap(int capacity)

  Deprecated.
  Construct an empty map with the specified capacity.
  Parameters:
    `capacity` - The initial capacity of the empty map

### FastHashMap

    public FastHashMap(int capacity,
                       float factor)

  Deprecated.
  Construct an empty map with the specified capacity and load factor.
  Parameters:
    `capacity` - The initial capacity of the empty map
    `factor` - The load factor of the new map

### FastHashMap

    public FastHashMap(java.util.Map map)

  Deprecated.
  Construct a new map with the same mappings as the specified map.
  Parameters:
    `map` - The map whose mappings are to be copied

Method Detail

### getFast

    public boolean getFast()

  Deprecated.

### setFast

    public void setFast(boolean fast)

  Deprecated.

### clear

    public void clear()

  Deprecated.
  Remove all mappings from this map.
  Overrides:
    `clear` in class `java.util.HashMap`

### clone

    public java.lang.Object clone()

  Deprecated.
  Return a shallow copy of this `FastHashMap` instance. The keys and values themselves are not copied.
  Overrides:
    `clone` in class `java.util.HashMap`

### containsKey

    public boolean containsKey(java.lang.Object key)

  Deprecated.
  Return `true` if this map contains a mapping for the specified key.
  Overrides:
    `containsKey` in class `java.util.HashMap`
  Parameters:
    `key` - Key to be searched for

### containsValue

    public boolean containsValue(java.lang.Object value)

  Deprecated.
  Return `true` if this map contains one or more keys mapping to the specified value.
  Overrides:
    `containsValue` in class `java.util.HashMap`
  Parameters:
    `value` - Value to be searched for

### entrySet

    public java.util.Set entrySet()

  Deprecated.
  Return a collection view of the mappings contained in this map. Each element in the returned collection is a `Map.Entry`.
  Overrides:
    `entrySet` in class `java.util.HashMap`

### equals

    public boolean equals(java.lang.Object o)

  Deprecated.
  Compare the specified object with this list for equality. This implementation uses exactly the code that is used to define the list equals function in the documentation for the `Map.equals` method.
  Overrides:
    `equals` in class `java.util.AbstractMap`
  Parameters:
    `o` - Object to be compared to this list

### get

    public java.lang.Object get(java.lang.Object key)

  Deprecated.
  Return the value to which this map maps the specified key. Returns `null` if the map contains no mapping for this key, or if there is a mapping with a value of `null`. Use the `containsKey()` method to disambiguate these cases.
  Overrides:
    `get` in class `java.util.HashMap`
  Parameters:
    `key` - Key whose value is to be returned

### hashCode

    public int hashCode()

  Deprecated.
  Return the hash code value for this map. This implementation uses exactly the code that is used to define the list hash function in the documentation for the `Map.hashCode` method.
  Overrides:
    `hashCode` in class `java.util.AbstractMap`

### isEmpty

    public boolean isEmpty()

  Deprecated.
  Return `true` if this map contains no mappings.
  Overrides:
    `isEmpty` in class `java.util.HashMap`

### keySet

    public java.util.Set keySet()

  Deprecated.
  Return a set view of the keys contained in this map.
  Overrides:
    `keySet` in class `java.util.HashMap`

### put

    public java.lang.Object put(java.lang.Object key,
                                java.lang.Object value)

  Deprecated.
  Associate the specified value with the specified key in this map. If the map previously contained a mapping for this key, the old value is replaced and returned.
  Overrides:
    `put` in class `java.util.HashMap`
  Parameters:
    `key` - The key with which the value is to be associated
    `value` - The value to be associated with this key

### putAll

    public void putAll(java.util.Map in)

  Deprecated.
  Copy all of the mappings from the specified map to this one, replacing any mappings with the same keys.
  Overrides:
    `putAll` in class `java.util.HashMap`
  Parameters:
    `in` - Map whose mappings are to be copied

### remove

    public java.lang.Object remove(java.lang.Object key)

  Deprecated.
  Remove any mapping for this key, and return any previously mapped value.
  Overrides:
    `remove` in class `java.util.HashMap`
  Parameters:
    `key` - Key whose mapping is to be removed

### size

    public int size()

  Deprecated.
  Return the number of key-value mappings in this map.
  Overrides:
    `size` in class `java.util.HashMap`

### values

    public java.util.Collection values()

  Deprecated.
  Return a collection view of the values contained in this map.
  Overrides:
    `values` in class `java.util.HashMap`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2001 - Apache Software Foundation